#include <Stepper.h> // stepper motor library

#define LEVER_SWITCH_PIN 49 // switch digital pin 
#define BUTTON_ONE_PIN 53 // button is set to digital pi
#define BUTTON_TWO_PIN 52 // button is set to di
#define BUTTON_THREE_PIN 51 // button is set 
#define START_BUTTON_PIN 50 // butto
#define PUMP_ONE 22
#define PUMP_TWO 24
#define PUMP_THREE 26
#define MIXER 12

int stepsPerRevolution = 200;// how many steps it takes to go 360 degrees
int speed = 50;// steps per second of stepper motor
Stepper X = Stepper(stepsPerRevolution, 8, 9, 10, 11);// stepper motor object with its digital pins
Stepper Z = Stepper(stepsPerRevolution, 4, 5, 6, 7);// stepper motor object with its digital pins
int StepsXFromZero;// keeps track of distance form zero

int action;//shows what step the machine is on

int totalPumpTime = 10;// time for one pump to pump a full red solo cup

int button1 = 0;
int button2 = 0;
int button3 = 0;

void setup() {
  Serial.begin(9600);
  pinMode(LEVER_SWITCH_PIN,INPUT);// sets end-action-switch to pin and as inputput
  pinMode(BUTTON_ONE_PIN, INPUT);//sets button to pin and as input
  pinMode(BUTTON_TWO_PIN, INPUT);//sets button to pin and as input
  pinMode(BUTTON_THREE_PIN, INPUT);//sets button to pin and as input
  pinMode(START_BUTTON_PIN, INPUT);//sets button to pin and as input
  pinMode(PUMP_ONE, OUTPUT);
  pinMode(PUMP_TWO, OUTPUT);
  pinMode(PUMP_THREE, OUTPUT);
  pinMode(MIXER, OUTPUT);
  
  X.setSpeed(speed);// actually makes the speed of stepper motor the speed we set earlier
  Z.setSpeed(200);
  action = 0;// sets action to 0 mode 
}

void loop() {




  
  if(action == 0){//if action is still on step 0
    int switchState = digitalRead(LEVER_SWITCH_PIN);//starts using action 0 to zero out the x-axis
    if(switchState == HIGH){//if the action switch is pressed
    X.step(-1);//go back 1
  }
  else{//if the action switcn is not flipped 
    StepsXFromZero = 0;// sets the origin or zero spot were it just ended up
    action = 1;//turn to step or action 1
    X.setSpeed(100);
    X.step(0);
  }  
  }





  
if(action == 1){
   if(digitalRead(BUTTON_ONE_PIN) == HIGH){
    if(button1 == 0){
      button1 = 1;
      Serial.println("1");
      delay(500);
    }
    else if(button1 == 1){
      button1 = 0;
      delay(500);
    }
}
if(digitalRead(BUTTON_TWO_PIN) == HIGH){
    if(button2 == 0){
      button2 = 1;
      Serial.println("2");
      delay(500);
    }
    else if(button2 == 1){
      button2 = 0;
      delay(500);
    }
}
if(digitalRead(BUTTON_THREE_PIN) == HIGH){
    if(button3 == 0){
      button3 = 1;
      Serial.println("3");
      delay(500);
    }
    else if(button3 == 1){
      button3 = 0;
      delay(500);
    }
}
if(digitalRead(START_BUTTON_PIN) == HIGH){
   action = 2;
}
}





if(action == 2){
  Z.step(1000);
  delay(1000);
  X.step(500);
  StepsXFromZero = StepsXFromZero + 500;
  if(button1 == 1){
    digitalWrite(PUMP_ONE, HIGH);
    delay(10000);
    digitalWrite(PUMP_ONE, LOW);
  }
  X.step(500);
  StepsXFromZero = StepsXFromZero + 500;
  if(button2 == 1){
    digitalWrite(PUMP_TWO, HIGH);
    delay(10000);
   digitalWrite(PUMP_TWO, LOW);
  }
  X.step(500);
   StepsXFromZero = StepsXFromZero + 500;
  if(button3 == 1){
    digitalWrite(PUMP_THREE, HIGH);
    delay(10000);
    digitalWrite(PUMP_THREE, LOW);
  }
  X.step(750);
  StepsXFromZero = StepsXFromZero + 750;
  action = 3;
  }




  

  if(action == 3){
    Z.step(-1000);
    digitalWrite(MIXER,HIGH);
    delay(5000);
    digitalWrite(MIXER,LOW);
    Z.step(1000);
    action = 4;
  }

  if(action == 4){
    delay(1000);
    X.step(-StepsXFromZero + 50);
    delay(5000);
    action = 0;
  }

 

 
 
   
}
 
